#!/usr/local/bin/phantomjs
###
request.coffee - Richard Schneider <rschneid@harding.edu>

Requests a url, using the specified user agent type.
Requests will timeout if they take longer than the TIMEOUT value.

usage:
    phantomjs request.coffee fixed|mobile url

Outputs:
 * A line giving the final status
 * A line giving the final url (after redirects, etc.)
 * The content of the page
 
###

#Import filesystem module
fs = require('fs')

#Chromium
FIXED_UA="Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.19 (KHTML, like Gecko) Ubuntu/12.04 Chromium/18.0.1025.151 Chrome/18.0.1025.151 Safari/535.19 (compatible; PhantomJS/1.5.0; +http://cs.harding.edu)"

#iPhone
MOBILE_UA="Mozilla/5.0 (iPhone; U; CPU iPhone OS 4_1 like Mac OS X; en-us) AppleWebKit/532.9 (KHTML, like Gecko) Version/4.0.5 Mobile/8B117 Safari/6531.22.7 (compatible; PhantomJS/1.5.0; +http://cs.harding.edu)"

#Timeout value and function
TIMEOUT=1000*60
doTimeout=->
    console.log "timeout"
    console.log "null"
    console.log "null"
    phantom.exit()

#Create page
page = require('webpage').create()

#Parse args
system = require('system')

if system.args.length!=3
    console.log "Usage: phantomjs request.coffee [fixed|mobile] url"
    phantom.exit()

#Set user agent and window size
userAgent=null
if system.args[1]=='fixed' or system.args[1]=='desktop'
    userAgent=FIXED_UA
    page.viewportSize={'width': 1280, 'height': 800}
else if system.args[1]=='mobile'
    userAgent=MOBILE_UA
    page.viewportSize={'width': 320, 'height': 480}
else
    console.log "Unknown user agent"
    phantom.exit()

page.settings.userAgent=userAgent
page.settings.loadImages=false
    
url=system.args[2]

#CSS awareness
css_files=[]
page.onResourceReceived = (response) ->    
    if /text\/css/i.test(response.contentType)
        css_files.push response.url

#Start timeout timer
setTimeout doTimeout, TIMEOUT

#Request page
page.open url, (status) ->
    #Print status, final URL, and content
    console.log status
    console.log page.evaluate 'function(){return window.location.toString();}'
    
    #New addition
    console.log css_files
    
    console.log page.content
    
    #Record the page for later purposes
    #urlStem=url.replace('http://', '')
    #fs.write('content/'+urlStem+'-'+system.args[1]+'.html', page.content, 'w')
    #page.render('render/'+urlStem+'-'+system.args[1]+'.png')
    
    phantom.exit()
