"""
logger.py

Logs stuff. Used unapologetically by most modules.
Can be turned off by setting stderr_enabled and log_file to None.

Initially configured by main.py.

"""
import sys

stderr_enabled=True
log_file=None

def log(message, newline=True):
    """Record a log message. newline tells whether to add a newline."""
    if newline:
        message+='\n'
    
    if stderr_enabled:
        sys.stderr.write(message)
        sys.stderr.flush()
        
    if log_file:
        log_file.write(message)
        log_file.flush()