"""
record.py

Contains generalized functions for processors to record found and
not found URLs in a standard form.

"""

from logger import log

def record_found(url, mobile_url, score, found_file, stats_file):
    log('\tmobile url found at %s' % mobile_url)
    
    found_file.write('%s %s\n' % (url, mobile_url))
    stats_file.write('%s %s %s\n' % (url, mobile_url, str(score)))
    
    found_file.flush()
    stats_file.flush()

def record_notfound(url, score, notfound_file, stats_file):
    log('\tmobile url not found')
    
    notfound_file.write('%s\n' % url)
    stats_file.write('%s none %s\n' % (url, str(score)))
    
    notfound_file.flush()
    stats_file.flush()