"""
get_urls.py
Get a sample of urls from Alexa's top one million.

Usage information:
    python get_sample.py --help
    
If Alexa changes the URL to the top one million data, SOURCE below will
need to be changed (and the whole script might break outright).

"""
import os
import sys
import datetime
import random
import argparse

SOURCE='http://s3.amazonaws.com/alexa-static/top-1m.csv.zip'

parser=argparse.ArgumentParser('Get a sample of URLs from Alexa')
parser.add_argument('output',
                    type=argparse.FileType('w'),
                    help='output file')
parser.add_argument('-n', '--number',
                    type=int, default=1000,
                    help='number of URLs (default 1000)')
parser.add_argument('-o', '--ordered',
                    action='store_true',
                    help='instead of randomizing URLs, use Alexa ranking order')

args=parser.parse_args()

print 'Retrieving source...'

os.system('wget %s' % SOURCE)
os.system('unzip top-1m.csv.zip')
os.system('rm top-1m.csv.zip')

lines=open('top-1m.csv').readlines()
    
os.system('rm top-1m.csv')

f=args.output
f.write('#'+str(datetime.datetime.now())+'\n')

print 'Sampling...'
if not args.ordered:
    random.shuffle(lines)

for i in range(args.number):
    url=lines.pop(0).strip().split(',')[1]
    f.write('http://www.'+url+'\n')

print 'Done'
